/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the GetActivitiesReport200ResponseInner type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GetActivitiesReport200ResponseInner{}

// GetActivitiesReport200ResponseInner struct for GetActivitiesReport200ResponseInner
type GetActivitiesReport200ResponseInner struct {
	Value int32 `json:"value"`
	Channel *string `json:"channel,omitempty"`
	Date *string `json:"date,omitempty"`
	Hour *string `json:"hour,omitempty"`
	Week *string `json:"week,omitempty"`
	Weekday *string `json:"weekday,omitempty"`
}

// NewGetActivitiesReport200ResponseInner instantiates a new GetActivitiesReport200ResponseInner object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGetActivitiesReport200ResponseInner(value int32) *GetActivitiesReport200ResponseInner {
	this := GetActivitiesReport200ResponseInner{}
	this.Value = value
	return &this
}

// NewGetActivitiesReport200ResponseInnerWithDefaults instantiates a new GetActivitiesReport200ResponseInner object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGetActivitiesReport200ResponseInnerWithDefaults() *GetActivitiesReport200ResponseInner {
	this := GetActivitiesReport200ResponseInner{}
	return &this
}

// GetValue returns the Value field value
func (o *GetActivitiesReport200ResponseInner) GetValue() int32 {
	if o == nil {
		var ret int32
		return ret
	}

	return o.Value
}

// GetValueOk returns a tuple with the Value field value
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetValueOk() (*int32, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Value, true
}

// SetValue sets field value
func (o *GetActivitiesReport200ResponseInner) SetValue(v int32) {
	o.Value = v
}

// GetChannel returns the Channel field value if set, zero value otherwise.
func (o *GetActivitiesReport200ResponseInner) GetChannel() string {
	if o == nil || IsNil(o.Channel) {
		var ret string
		return ret
	}
	return *o.Channel
}

// GetChannelOk returns a tuple with the Channel field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetChannelOk() (*string, bool) {
	if o == nil || IsNil(o.Channel) {
		return nil, false
	}
	return o.Channel, true
}

// HasChannel returns a boolean if a field has been set.
func (o *GetActivitiesReport200ResponseInner) HasChannel() bool {
	if o != nil && !IsNil(o.Channel) {
		return true
	}

	return false
}

// SetChannel gets a reference to the given string and assigns it to the Channel field.
func (o *GetActivitiesReport200ResponseInner) SetChannel(v string) {
	o.Channel = &v
}

// GetDate returns the Date field value if set, zero value otherwise.
func (o *GetActivitiesReport200ResponseInner) GetDate() string {
	if o == nil || IsNil(o.Date) {
		var ret string
		return ret
	}
	return *o.Date
}

// GetDateOk returns a tuple with the Date field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetDateOk() (*string, bool) {
	if o == nil || IsNil(o.Date) {
		return nil, false
	}
	return o.Date, true
}

// HasDate returns a boolean if a field has been set.
func (o *GetActivitiesReport200ResponseInner) HasDate() bool {
	if o != nil && !IsNil(o.Date) {
		return true
	}

	return false
}

// SetDate gets a reference to the given string and assigns it to the Date field.
func (o *GetActivitiesReport200ResponseInner) SetDate(v string) {
	o.Date = &v
}

// GetHour returns the Hour field value if set, zero value otherwise.
func (o *GetActivitiesReport200ResponseInner) GetHour() string {
	if o == nil || IsNil(o.Hour) {
		var ret string
		return ret
	}
	return *o.Hour
}

// GetHourOk returns a tuple with the Hour field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetHourOk() (*string, bool) {
	if o == nil || IsNil(o.Hour) {
		return nil, false
	}
	return o.Hour, true
}

// HasHour returns a boolean if a field has been set.
func (o *GetActivitiesReport200ResponseInner) HasHour() bool {
	if o != nil && !IsNil(o.Hour) {
		return true
	}

	return false
}

// SetHour gets a reference to the given string and assigns it to the Hour field.
func (o *GetActivitiesReport200ResponseInner) SetHour(v string) {
	o.Hour = &v
}

// GetWeek returns the Week field value if set, zero value otherwise.
func (o *GetActivitiesReport200ResponseInner) GetWeek() string {
	if o == nil || IsNil(o.Week) {
		var ret string
		return ret
	}
	return *o.Week
}

// GetWeekOk returns a tuple with the Week field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetWeekOk() (*string, bool) {
	if o == nil || IsNil(o.Week) {
		return nil, false
	}
	return o.Week, true
}

// HasWeek returns a boolean if a field has been set.
func (o *GetActivitiesReport200ResponseInner) HasWeek() bool {
	if o != nil && !IsNil(o.Week) {
		return true
	}

	return false
}

// SetWeek gets a reference to the given string and assigns it to the Week field.
func (o *GetActivitiesReport200ResponseInner) SetWeek(v string) {
	o.Week = &v
}

// GetWeekday returns the Weekday field value if set, zero value otherwise.
func (o *GetActivitiesReport200ResponseInner) GetWeekday() string {
	if o == nil || IsNil(o.Weekday) {
		var ret string
		return ret
	}
	return *o.Weekday
}

// GetWeekdayOk returns a tuple with the Weekday field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GetActivitiesReport200ResponseInner) GetWeekdayOk() (*string, bool) {
	if o == nil || IsNil(o.Weekday) {
		return nil, false
	}
	return o.Weekday, true
}

// HasWeekday returns a boolean if a field has been set.
func (o *GetActivitiesReport200ResponseInner) HasWeekday() bool {
	if o != nil && !IsNil(o.Weekday) {
		return true
	}

	return false
}

// SetWeekday gets a reference to the given string and assigns it to the Weekday field.
func (o *GetActivitiesReport200ResponseInner) SetWeekday(v string) {
	o.Weekday = &v
}

func (o GetActivitiesReport200ResponseInner) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GetActivitiesReport200ResponseInner) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["value"] = o.Value
	if !IsNil(o.Channel) {
		toSerialize["channel"] = o.Channel
	}
	if !IsNil(o.Date) {
		toSerialize["date"] = o.Date
	}
	if !IsNil(o.Hour) {
		toSerialize["hour"] = o.Hour
	}
	if !IsNil(o.Week) {
		toSerialize["week"] = o.Week
	}
	if !IsNil(o.Weekday) {
		toSerialize["weekday"] = o.Weekday
	}
	return toSerialize, nil
}

type NullableGetActivitiesReport200ResponseInner struct {
	value *GetActivitiesReport200ResponseInner
	isSet bool
}

func (v NullableGetActivitiesReport200ResponseInner) Get() *GetActivitiesReport200ResponseInner {
	return v.value
}

func (v *NullableGetActivitiesReport200ResponseInner) Set(val *GetActivitiesReport200ResponseInner) {
	v.value = val
	v.isSet = true
}

func (v NullableGetActivitiesReport200ResponseInner) IsSet() bool {
	return v.isSet
}

func (v *NullableGetActivitiesReport200ResponseInner) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGetActivitiesReport200ResponseInner(val *GetActivitiesReport200ResponseInner) *NullableGetActivitiesReport200ResponseInner {
	return &NullableGetActivitiesReport200ResponseInner{value: val, isSet: true}
}

func (v NullableGetActivitiesReport200ResponseInner) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGetActivitiesReport200ResponseInner) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


